Imports System
Imports System.IO
Imports System.IO.Ports
Imports System.Text

Module Program

	Sub Main(args As String())
		While True
			Try
				Using SR As New SerialPort(args(0))
					SR.BaudRate = 115200
					SR.Open()
					While True
						Dim buffer(180) As Byte
						Dim offset = 0
						While offset <> buffer.Length
							Dim read = SR.Read(buffer, offset, buffer.Length - offset)
							If read = 0 Then
								Console.WriteLine("Error while reading from serial port.")
							End If
							offset += read

							If Encoding.ASCII.GetString(buffer, 0, offset).Contains(vbCrLf) Then
								Exit While
							End If

							Threading.Thread.Sleep(10)
						End While
						Dim line = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") & ":" & Encoding.ASCII.GetString(buffer, 0, offset).Trim()
						Using sw As New StreamWriter("packets.txt", True)
							sw.WriteLine(line)
							Console.WriteLine(line)
							sw.Flush()
						End Using
					End While
				End Using
			Catch ex As Exception
				Console.WriteLine($"COM port listening failed with exception: {ex.GetType().Name}: {ex.Message}")
				Console.WriteLine(ex.StackTrace)
			End Try
		End While
	End Sub

End Module
